#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sched.h>

#define DWCS_WORK_CONS	0x00000002 /* Does task support work-conservation? */
#define DWCS_NON_PREEMPTIVE 0x00000004 /* Set when process is non-preemptive */

int main (int argc, char *argv[]) {
  struct sched_param sp;
  int ret;
  int pid;
  int mark;
  
  if (argc < 5) {
    fprintf (stderr, "Enter: %s <pid> <period> <own> <owd> "
	     "[-s <service time>] [-f DWCS_WORK_CONS,DWCS_NON_PREEMPTIVE]\n", 
	     argv[0]);
    exit (1);
  }
    
  pid       = atoi(argv[1]);
  sp.period = atol(argv[2]);
  sp.own    = atoi(argv[3]);
  sp.owd    = atoi(argv[4]);

  /* The following are defaults. */
  sp.flags  = 0;
  sp.service_time = 1;	/* x10mS clock resolution on Intel machines. */

  if (argc >= 7) {
    mark = 5;
    while (argc > 5) {
      if (strcmp (argv[mark], "-s") == 0) {
	argc--; mark++;

	sp.service_time = atol(argv[mark]);

	argc--; mark++;
	continue;
      }
      
      if (strcmp (argv[mark], "-f") == 0) {
	argc--; mark++;
	
	if (strstr (argv[mark], "DWCS_WORK_CONS"))
	  sp.flags  |= DWCS_WORK_CONS;
	if (strstr (argv[mark], "DWCS_NON_PREEMPTIVE"))
	  sp.flags  |= DWCS_NON_PREEMPTIVE;
	
	argc--; mark++;
	continue;
      }
    }
  }
  
  if ((ret = sched_setscheduler (pid, SCHED_DWCS, &sp)) < 0)
    fprintf (stderr, "Error setting scheduling attributes!\n");
  
  return ret;
}
